# -*- coding: utf-8 -*-
#
# Copyright (C) 2020 Avencall
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>
from sqlalchemy.schema import Column, ForeignKey, PrimaryKeyConstraint, Index, \
    UniqueConstraint, ForeignKeyConstraint
from sqlalchemy import select, func, UniqueConstraint
from sqlalchemy.orm import relationship, column_property
from sqlalchemy.types import Integer, String, Text
from xivo_dao.helpers.db_manager import Base


class Contact_Label (Base):
    __tablename__ = 'contact_label'
    __table_args__ = (
        PrimaryKeyConstraint('id'),
        UniqueConstraint('label_name'),
        Index('contact_label__idx__label_name', 'label_name'),

    )

    id = Column(Integer, nullable=False, autoincrement=True)
    label_name = Column(String(128), nullable=False, unique=True)
    description = Column(Text)

    contact = relationship("Contact", secondary="contact_label_contact", back_populates="contact_label")

    