# -*- coding: utf-8 -*-

# Copyright (C) 2020 Avencall
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>
from sqlalchemy import Column, ForeignKey, PrimaryKeyConstraint, Index, \
         UniqueConstraint, ForeignKeyConstraint
from sqlalchemy.orm import relationship, backref
from sqlalchemy.schema import Column
from sqlalchemy.types import Integer

from xivo_dao.helpers.db_manager import Base


class Contact_Label_Contact (Base):

    __tablename__ = 'contact_label_contact'

    __table_args__= (
        PrimaryKeyConstraint('id'),
        Index('contact_label_contact__idx__contact_id', 'contact_id'),
        Index('contact_label_contact__idx__contact_label_id', 'contact_label_id'),
    )


    id = Column(Integer, primary_key=True)
    contact_id = Column(Integer, ForeignKey('contact.id', ondelete='CASCADE'))
    contact_label_id = Column(Integer, ForeignKey('contact_label.id', ondelete='CASCADE'))
     
    contact = relationship("Contact", backref=backref("contact_label_contact"))
    contact_label = relationship("Contact_Label", backref=backref("contact_label_contact"))

  